using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace XNA_Gestures3
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        //Kreis Grafik
        Texture2D kreis;
        //Position des Kreises
        Vector2 kreisPositionOrig;
        //Ursprüngliche Skalierung
        float Skalierung = 1.0f;
        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            //Vollbildmodus
            graphics.IsFullScreen = true;
            // Frame rate is 30 fps by default for Windows Phone.
            TargetElapsedTime = TimeSpan.FromTicks(333333);
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here
            //Gesten aktivieren.
            TouchPanel.EnabledGestures = GestureType.Pinch | GestureType.PinchComplete;

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            //Kreis Grafik laden
            kreis = Content.Load<Texture2D>("Kreis");
            //Position zentriert setzen. Spiel ist in Landscape Modus, daher X  & Y vertauschen
            kreisPositionOrig.Y = (graphics.GraphicsDevice.DisplayMode.Width / 2);
            kreisPositionOrig.X = (graphics.GraphicsDevice.DisplayMode.Height / 2);
            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();
            
            //Alle aktuell vorhanden gesten auswerten
            while (TouchPanel.IsGestureAvailable)
            {
                //Die aktuelle Geste auslesen
                GestureSample curGesture = TouchPanel.ReadGesture();
                //Gestentyp prüfen
                switch (curGesture.GestureType)
                {
                    case GestureType.PinchComplete:
                        break;
                    case GestureType.Pinch:
                        {
                            //Skalierung anpassen
                            //Distanz zwischen den Aktuellen Positionen bestimmen
                            float DistanzNeu = Vector2.Distance(curGesture.Position, curGesture.Position2);
                            //Distanz zwischen den vorherigen Positionen(Abzug des Deltawertes) bestimmen
                            float DistanzAlt = Vector2.Distance(curGesture.Position - curGesture.Delta, curGesture.Position2 - curGesture.Delta2);
                            //Die aktuelle Skallierung Anpassen
                            Skalierung += (DistanzNeu - DistanzAlt) * 0.01f;
                            //Minimal & Maximalwerte für die Skalierung setzen
                            if (Skalierung < 0.1f)
                                Skalierung = 0.1f;
                            if (Skalierung > 15)
                                Skalierung = 15;
                        }
                        break;
                }
            }
            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin();

            spriteBatch.Draw(
                kreis, //Zu zeichnende Textur
                kreisPositionOrig, //Position
                null, //nicht nötig
                Color.White,//Ohne Änderung (einfärben) zeichen
                0, //Keine Rotation
                new Vector2(kreis.Width / 2, kreis.Height / 2),//Zeichen von der Mitte des Sprites aus
                Skalierung,//Die eigentliche Skalierung
                SpriteEffects.None,//Ohne Effekte
                0);//Ohne Layer


            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
